// FUSE Fcpu =9600000 Hz & DIV 8 = 1200000Hz

#include <avr/io.h>
#include <avr/interrupt.h>

unsigned char T =200; // 
unsigned char ts =1; //   =  
unsigned char tu =90; //  ,    ADC


ISR(INT0_vect) //     ""
{
  TCNT0 =0;
  sei(); //   .
  ADCSRA |=0b01000000; //  
}

ISR(ADC_vect) //  -  
{
  sei(); //   .

  tu =T /2 -(unsigned int)ADCW /11; //     
  
  if (ts <tu) ts++;
  else if (ts >tu) ts--;

  OCR0A =ts;   // Output Compare Register A -  
  OCR0B =T -ts; // Output Compare Register B -  

  __asm__ __volatile__ ("wdr"::);
}


ISR(TIM0_COMPA_vect)
{
  PORTB &= 0b11111110;  //  
}

ISR(TIM0_COMPB_vect)
{
  PORTB |= 0b00000001;  //  
}


int main (void)
{
// 
   DDRB = 0b000001; // PB4=ADC1; PB1=INT0; PB0=OUT;
  PORTB = 0b101110; //   ; int0 -  ;   ,

//  T0
  TCCR0B = 0b00000011;
  //              ||| CS02:0 000-stop; 001/1; 010/8; 011/64; 100/256; 101/1024; 110-T0|_; 111-T0_|   1200000/64 =18750
  TIMSK0 = 0b00001100;
  //             | OCIE0B     A
  //              | OCIE0A     B
  
  OCR0A =0;   // Output Compare Register A  
  OCR0B =200; // Output Compare Register B  

//  
  MCUCR =0b00000011;
  //             ||    00- , 01- , 10-, 11-
  GIMSK = 0b01000000; // General Interrupt Mask Register, bit6 =INT0

// 
  ADCSRA =0b11001011;
  //             ||| ADPS2..0   000/2, 001/2, 010/4, 011/8, 100/16, 101/32, 110/64, 111/128; 1200000/16 =75kHz; 1200000/8 =150kHz
  //            | ADIE    
  //         | ADCC  
  //        | ADEN  
  ADCSRB =0b00000000;
  //             ||| ADTS2..0    . 010-INT0.
  //         | ACME        
  ADMUX =0b01000010;
  //             || MUX1:0   00=ADC0, 01=ADC1, 10=ADC2, 11=ADC3
  //        | REFS0  0=Vcc, 1=1.1V

//  
  WDTCR = 0b00001000;
  //             ||| WDP2WDP0  Vcc=5V 000=16ms; 001~32ms; 010~64ms; 011~.125s; 100~.25s; 101~.5s; 110~1s; 111~2s
  //            | WDE    (1  )
  //           | WDTOE    
  //          | WDP3 1000~4s; 1001~8s

  sei(); //   .

  while (1);
}
